unit PGAppWnd;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages;

{ Returns the handle of the parent to the Application window. }
function PGApplicationHandle: LongInt;
function PGShouldHideApplicationWindow: Boolean;

implementation

{$F+}
var
  hPGApplication: LongInt;
  PGApplicationWindowClass: TWndClass;
  TempClass: TWndClass;

const
  PG_UNINITIALIZED_APPLICATION_HANDLE = -42;

function PGShouldHideApplicationWindow: Boolean;
begin
{$IFDEF WIN32}
  Result := (hPGApplication <> PG_UNINITIALIZED_APPLICATION_HANDLE);
{$ELSE}
  Result := false;
{$ENDIF}
end;

function PGApplicationHandle: LongInt;
begin
  if not GetClassInfo(HInstance, PGApplicationWindowClass.lpszClassName, TempClass) then
    begin
    PGApplicationWindowClass.hInstance := HInstance;
{$IFDEF WIN32}
    if (WinProcs.RegisterClass(PGApplicationWindowClass) = 0) then
{$ELSE}
    if not WinProcs.RegisterClass(PGApplicationWindowClass) then
{$ENDIF}
       raise Exception.Create('Couldnt register window class: TPGApplication');
    hPGApplication := CreateWindow(PGApplicationWindowClass.lpszClassName,'',WS_POPUP,
                    GetSystemMetrics(SM_CXSCREEN) div 2, GetSystemMetrics(SM_CYSCREEN) div 2,
                    50,50,0,0,HInstance,nil);
    end;
  Result := hPGApplication;
end;

{$IFNDEF WIN32}
procedure DonePGApp; far;
begin
  DestroyWindow(hPGApplication);
end;
{$ENDIF}

initialization
  hPGApplication := PG_UNINITIALIZED_APPLICATION_HANDLE;

  { Initialize our own Application Window Class }
  PGApplicationWindowClass.style := 0;
  PGApplicationWindowClass.lpfnWndProc := @DefWindowProc;
  PGApplicationWindowClass.cbClsExtra := 0;
  PGApplicationWindowClass.cbWndExtra := 0;
  PGApplicationWindowClass.hInstance := 0;
  PGApplicationWindowClass.hIcon := 0;
  PGApplicationWindowClass.hCursor := 0;
  PGApplicationWindowClass.hbrBackground := 0;
  PGApplicationWindowClass.lpszMenuName := nil;
  PGApplicationWindowClass.lpszClassName := 'TPGApplication';

{$IFNDEF WIN32}
  AddExitProc(DonePGApp);
{$ENDIF}

{$IFDEF WIN32}
finalization
  DestroyWindow(hPGApplication);
{$ENDIF}

end.
