unit PGHide32;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages;

implementation

{$F+}

{$IFNDEF WIN32}
uses Forms, Dialogs;

var
  AnInfoMsg: string;
{$ENDIF}


{$IFDEF WIN32}
uses PGAppWnd;

var
  PGReturnedHook: LongInt;

procedure PGStartCallWndProcHook; forward;
procedure PGStopCallWndProcHook; forward;

function MyCallWndProcHook(Code: Integer; wParam: word; lParam: LongInt): Longint; stdcall;
var
  CallWndProcInfo: TCWPStruct;
  hWnd: THandle;
  szClassName: array[0..255] of char;
begin
  if code < 0 then
    begin
    Result := CallNextHookEx(PGReturnedHook, Code, wParam, lParam);
    exit;
    end;

  Result := 0;
      
  CallWndProcInfo := TCWPStruct(Pointer(lParam)^);
  if (CallWndProcInfo.message = WM_CREATE) then
    begin
    hWnd := CallWndProcInfo.hWnd;

    if GetClassName(hWnd, szClassName, SizeOf(szClassName)) <> 0 then
      begin
      if StrComp(szClassName, 'TApplication') = 0 then
        begin
        SetParent(hWnd, PGApplicationHandle);
        PGStopCallWndProcHook;
        end;
      end;
    end;
end;

procedure PGStartCallWndProcHook;
begin
  PGReturnedHook := SetWindowsHookEx(WH_CALLWNDPROC, @MyCallWndProcHook, HInstance, GetCurrentThreadId);
end;

procedure PGStopCallWndProcHook;
begin
  UnHookWindowsHookEx(PGReturnedHook);
end;
{$ENDIF}

initialization
{$IFNDEF WIN32}
  { Let any Delphi 1.0 users that try to use this unit know that it won't do }
  { anything for them, and that they should remove it from their uses clause. }
  AnInfoMsg := 'The PGHide32 unit isnt needed for Delphi 1.X !!!' + #10#10;
  AnInfoMsg := AnInfoMsg + 'Remove the PGHide32 unit from your uses' + #10;
  AnInfoMsg := AnInfoMsg + 'clause and take a look at the topic' + #10;
  AnInfoMsg := AnInfoMsg + '"Frequently Asked Questions" in the' + #10;
  AnInfoMsg := AnInfoMsg + 'PGTRAY95.HLP file for more information' + #10;
  AnInfoMsg := AnInfoMsg + 'on how to hide your application on initial ' + #10;
  AnInfoMsg := AnInfoMsg + 'startup.' + #10;
  MessageDlg(AnInfoMsg, mtInformation, [mbOk], 0);
  Application.Terminate;
{$ELSE}

  { Create a hidden window of our own windows class type for hiding the }
  { application on initial startup under Delphi 2.0, and for converting }
  { icon handles to 32 bits under Delphi 1.0 }
  PGApplicationHandle;
  LockWindowUpdate(GetDesktopWindow);
  PGStartCallWndProcHook;
  LockWindowUpdate(0);

finalization
  PGStopCallWndProcHook;
{$ENDIF}

end.
